<template>
  <div>
    <slot :handleSubmit="handleSubmit"></slot>
  </div>
</template>

<script>
export default {
  name: "Vuemik",
  data() {
    return {
      values: this.initValues,
    };
  },
  props: {
    initValues: {
      type: Object,
      default: () => ({}),
    },
    onSubmit: {
      type: Function,
      default: () => {},
    },
  },
  methods: {
    handleSubmit: function () {
      this.onSubmit(this.values);
    },
    handleChange(name, value) {
      this.values[name] = value;
    },
  },
  provide() {
    return {
      vuemik: {
        values: this.values,
        handleSubmit: this.handleSubmit,
        change: this.handleChange,
      },
    };
  },
};
</script>